indexing

	description: "Test Posix memory mapping class."

  author: "Berend de Boer"
	date: "$Date: 2001/12/27 $"
	revision: "$Revision: #1 $"

class TEST_P_MEMORY_MAP

inherit
   
   POSIX_SYSTEM
   
   POSIX_CURRENT_PROCESS

   POSIX_FILE_SYSTEM
   

creation
   
   make
   
feature
   
   make is
      local
         fd: POSIX_FILE_DESCRIPTOR
         map: POSIX_MEMORY_MAP
         byte: INTEGER
      do
         print ("testing Posix memory mapping interface.%N")

         if not supports_memory_mapped_files then
            print ("Memory mapped files are not supported.%N")
            exit (0)
         end
         
         print ("Create a file.%N")
         create fd.create_read_write ("test.berend")
         fd.write_string ("hello world.")
         
         print ("create memory map.%N")
         create map.make_shared (fd, 0, 6)
         
         print ("Read a byte from the mapping.%N")
         byte := map.mem.peek_uint8 (5)
         if byte /= 32 then
            print ("!! Expected to read a space.%N")
         end
         map.close
         
         fd.close
         
         remove_file ("test.berend")

         print ("End of Posix memory map test.%N")
      end
   
end -- class TEST_P_MEMORY_MAP
