indexing

	description: "Test POSIX signal class."

  author: "Berend de Boer"
	date: "$Date: 2001/12/27 $"
	revision: "$Revision: #1 $"


class

   TEST_P_SIGNAL


inherit

   POSIX_CONSTANTS

   POSIX_SIGNAL_HANDLER

   POSIX_FORK_ROOT


creation

   make


feature

   handled: BOOLEAN

   signal: POSIX_SIGNAL

   b: BOOLEAN

   make is
      local
         signal_set: POSIX_SIGNAL_SET
      do
         print ("Begin test posix signal.%N")

         create signal.make (SIGTERM)
         signal.set_ignore_action
         signal.apply
         signal.set_default_action
         signal.apply
         signal.set_handler (Current)
         signal.apply
         signal.raise

         sleep (2)
         if not handled then
            print ("!! not handled.%N")
         end

         print ("Test pause function.%N")
         fork (Current)
         sleep (1)
         signal.raise_in (last_child_pid)
         wait
         sleep (2)

         print ("Test signal set.%N")
         create signal_set.make_empty
         create signal_set.make_full
         if not signal_set.has (SIGTERM) then
            print ("!! SIGTERM is not a member.%N")
         end
         signal_set.prune (SIGTERM)
         if signal_set.has (SIGTERM) then
            print ("!! SIGTERM is still a member.%N")
         end

         create signal_set.make_empty
         signal_set.extend (SIGTERM)
         signal_set.add_to_blocked_signals
         signal.raise
         create signal_set.make_pending
         if not signal_set.has (SIGTERM) then
            print ("!! SIGTERM is not pending.%N")
         end
         -- give raised signal a chance to be processes
         signal_set.remove_from_blocked_signals
         sleep (2)

         print ("Suspend until SIGALRM received.%N")
         create signal.make (SIGALRM)
         signal.set_handler (Current)
         signal.apply
         cancel_alarm
         alarm (2)
         -- make sure SIGALRM is not blocked
         create signal_set.make_full
         signal_set.prune (SIGALRM)
         signal_set.suspend

         -- chance for signal to be delivered?
         sleep (1)

         print ("End test posix signal.%N")
      end

   signalled (signal_value: INTEGER) is
      do
         -- print ("signalled.%N")
         reestablish (signal_value)
         if not b then
            b := True
            signal.raise
         else
            handled := True
         end
      end

   execute is
      do
         print ("child.%N")
         pause
         print ("More test.%N")
         sleep (1)
      end

end -- class TEST_P_SIGNAL
